%Upper and lower bound error calculator
% f = k * w^a * x^b /( y^c * z*d )
function upper_and_lower_bounds
clc; disp(' '); disp(' UPPER AND LOWER BOUND CALCULATOR ')
disp(' f = k * w^a * x^b /( y^c * z*d ) '); disp(' ')

%Get parameters from Excel
[k,w,x,y,z,sigma_w,sigma_x,sigma_y,sigma_z,a,b,c,d] = get_data_from_excel;

%Calculate outputs
mean_f = k * (w^a) * (x^b) /( (y^c) * (z^d) );
f_upper = k *...
    ( ( (w+sigma_w)^a ) * ( (x+sigma_x)^b ) ) /...
    ( ( ( y - sigma_y)^c ) * (( z-sigma_z)^d ) );
f_lower = k *...
    ( ( (w-sigma_w)^a ) * ( (x-sigma_x)^b ) ) /...
    ( ( ( y + sigma_y)^c ) * (( z+sigma_z)^d ) );

gaussian_f_error = mean_f *...
    sqrt( ( a*sigma_w/w)^2 + ( b*sigma_x/x)^2 +...
    ( c*sigma_y/y)^2 + ( d*sigma_z/z)^2 );

%Display message to command window
disp([' k = ',num2str(k) ]);
disp([' w = ',num2str(w),' +/- ',num2str(sigma_w),', a = ',num2str(a)]);
disp([' x = ',num2str(x),' +/- ',num2str(sigma_x),', b = ',num2str(b) ]);
disp([' y = ',num2str(y),' +/- ',num2str(sigma_y),', c = ',num2str(c) ]);
disp([' z = ',num2str(z),' +/- ',num2str(sigma_z),', d = ',num2str(d) ]);
disp(' ');
disp([' Mean f = ',num2str(mean_f) ] );
disp([' Upper f - Mean f = ',num2str(f_upper - mean_f) ] );
disp([' Mean f - Lower f = ',num2str(mean_f - f_lower) ] );
disp([' Gaussian f error = ',num2str(gaussian_f_error) ] ); disp(' ');

%%

%Get parameters from Excel
function [k,w,x,y,z,sigma_w,sigma_x,sigma_y,sigma_z,a,b,c,d] = get_data_from_excel
[num,txt,raw] = xlsread('upper and lower bound calculator.xlsx');
k = num(1,1); 
w = num(3,1); sigma_w = num(3,3); a = num(3,6); 
x = num(4,1); sigma_x  = num(4,3); b = num(4,6);  
y = num(5,1); sigma_y  = num(5,3); c = num(5,6); 
z = num(6,1); sigma_z = num(6,3); d = num(6,6); 
 
%End of code
 
 